unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, ExtCtrls, mmsystem, StdCtrls;

const soot: array [0..3,0..3] of char = (('', '', '', ''),('', '', '', ''),('', '', '', ''),('', '', '', ''));
      curiosity: array [0..3] of char = ('U', 'D', 'L' ,'R');
      dX=16;
      dY=24;
      Goal:char='';  //    

type
  trgb = record 
   b,g,r: byte;
  end;
  ARGB = array [0..0] of TRGB;
  PARGB = ^ARGB;

  reflex = record
   receptor:string; //        ,        
   effector:string;
  end; 

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    Label1: TLabel;
    Memo2: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    Memo3: TMemo;
    Label4: TLabel;
    Memo4: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
  public
    function GetPos:char;
    procedure SetPos(x:char);
    procedure CheckGoal;
    procedure Executing;
    procedure Experiencing;
    procedure UpdateNowsens;
    procedure Creating;
    procedure Forgetting;
  end;

var
  Form1: TForm1;
  pole,buf:tbitmap;
  PS:array of PARGB;
  FX,FY:integer; //   F
  ismoov:boolean = false;
  timer,event1:thandle;
  nowsens,postsens:array of string; //     
  skills: array of reflex; // -   ! :)
  InteriorReceptor:string; //  ,       -   ,  ,  ,  

implementation

{$R *.dfm}

procedure bres_circle(xc,yc,radius:integer; r,g,b:byte); // Bresenham's (Pitteway and van Aken) algorithm
 var a,c,d:integer;
 procedure sim(x,y:integer; r,g,b:byte);
  var i,j:integer;
 begin
  i:=xc+x;
  j:=yc+y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  j:=yc-y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc-x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  j:=yc+y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc+y;
  j:=yc+x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  j:=yc-x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc-y;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
  i:=xc-y;
  j:=yc+x;
  PS[j,i].r:=r; PS[j,i].g:=g; PS[j,i].b:=b;
 end;
begin
 a:=0;
 c:=radius;
 d:=3-2*c;
 while(a<=c) do begin
  sim(a,c,r,g,b);
  if d<0 then d:=d+4*a+8
  else begin
   d:=d+4*(a-c)+10;
   dec(c);
  end;
  inc(a)
 end;
end;

procedure CallBackTime(TimerID, uMessage: UINT;dwUser, dw1, dw2: DWORD) stdcall;
begin
 SetEvent(event1);
end;

procedure Move(dir:byte); // 0 - , 1 - , 2 - , 3 - 
 var i:integer;
begin
 for i:=1 to 30 do begin
  case dir of
   0:if FX>15 then dec(FX) else break;
   1:if FX<105 then inc(FX) else break;
   2:if FY>15 then dec(FY) else break;
   3:if FY<105 then inc(FY) else break;
  end;
  Timer:=timeSetEvent(5,0,@CallBackTime,0,TIME_ONESHOT);
  WaitForSingleObject(event1, infinite);
  timeKillEvent(Timer);
  form1.FormPaint(nil);
 end;
 InteriorReceptor:=''; //     ,   ,    
end;

procedure TForm1.Executing; //   (, )
 var i,j:integer;
     trigger:boolean;
 procedure Execute(effector:string); //      
 begin
  case effector[1] of
   'r': InteriorReceptor:=effector[2]; //   
   'e': move(strtoint(effector[2]));   //  -   (0 - , 1 - , 2 - , 3 - )
   'C': InteriorReceptor:=curiosity[random(4)]; //       
  end;  //        -  () 
 end;
begin
 for i:=0 to high(skills) do begin
  trigger:=false;
  for j:=0 to high(nowsens) do  //   ,    -   
   if skills[i].receptor=nowsens[j] then begin
    execute(skills[i].effector);
    trigger:=true;
    break;
   end;
  if trigger then break; // ,   1-   
 end;
end;

procedure TForm1.Experiencing; //     ( )
 var i,j:integer;
 trigger:boolean;
 temp:string;
begin
 UpdateNowsens; //   

 //      .       .     
 memo1.Clear;
 for i:=0 to high(nowsens) do begin //    ""   ""
  trigger:=true;
  for j:=0 to high(postsens) do if nowsens[i]=postsens[j] then begin trigger:=false; break; end;
  if trigger then memo1.Lines.Add(nowsens[i]); //    ,  ""
 end;

 memo2.Clear;
 for i:=0 to high(postsens) do begin //    ""  ""
  trigger:=true;
  for j:=0 to high(nowsens) do if postsens[i]=nowsens[j] then begin trigger:=false; break; end;
  if trigger then memo2.Lines.Add(postsens[i]); //   ,  ""
 end;

 if (memo1.Text<>'')and(memo2.Text<>'') then begin
  temp:=memo1.Text+' - '+memo2.Text;
  repeat  //   
   i:=pos(#13+#10,temp);
   if i<>0 then delete(temp,i,2);
  until i=0;
  trigger:=true;
  for i:=0 to memo3.Lines.Count do if temp=memo3.Lines[i] then trigger:=false;
  if trigger then memo3.Lines.Add(temp) //       
  end;
end;

procedure TForm1.Creating; //       ()
 var Continuity:boolean; //     
     links:array of reflex; //   ,       
     tree: array of array of reflex; //      
     i,j,l,m:integer;
     str:string;
     now:array of char; //  
     NowPos:char;
     br:boolean;
begin 
 if checkbox1.Checked then begin //     ,      

  links:=nil;  //      
  for i:=0 to memo3.Lines.Count do begin
   l:=length(memo3.Lines[i]);
   if l>5 then begin  //     ,    
    setlength(links,length(links)+1);
    links[high(links)].effector:=memo3.Lines[i][1]; //  ,     
    links[high(links)].receptor:=copy(memo3.Lines[i],5,l-4); //  ,    
   end;
  end;

  Continuity:=false; //     

  tree:=nil;
  setlength(tree,1); //   ,    ,     
  for i:=0 to high(links) do
   if pos('',links[i].receptor)>0 then begin
    setlength(tree[0],length(tree[0])+1);
    tree[0][high(tree[0])].receptor:=links[i].receptor;
    tree[0][high(tree[0])].effector:=links[i].effector;
    links[i].receptor:=''; //     
    links[i].effector:=''; 
   end;

  if length(tree[0])>0 then begin //     -        

   repeat
    now:=nil;
    for i:=0 to high(tree[high(tree)]) do begin //     
     setlength(now,length(now)+1); //  
     now[high(now)]:=tree[high(tree)][i].receptor[1];
    end;
    setlength(tree,length(tree)+1); //   
    for i:=0 to high(now) do
     for j:=0 to high(links) do
      if pos(now[i],links[j].effector)>0 then begin
       setlength(tree[high(tree)],length(tree[high(tree)])+1);
       tree[high(tree)][high(tree[high(tree)])].receptor:=links[j].receptor;
       tree[high(tree)][high(tree[high(tree)])].effector:=links[j].effector;
       links[j].receptor:=''; //     
       links[j].effector:='';
      end;
   until length(tree[high(tree)])=0; //      

   NowPos:=GetPos;
   br:=false;
   l:=0;
   m:=0;
   for i:=0 to high(tree)-1 do begin //      
    for j:=0 to high(tree[i]) do begin
     if pos(NowPos,tree[i][j].receptor)>0 then begin //    
      Continuity:=true;
      br:=true;
      l:=i; //    
      m:=j;
      break;
     end;
    end;
    if br then break;
   end;

   if Continuity then 
    for i:=l downto 0 do begin  //    
     setlength(skills,length(skills)+1);
     skills[high(skills)].receptor:=tree[i][m].receptor[1];
     skills[high(skills)].effector:='r'+tree[i][m].receptor[2];
     if i<>0 then begin
      for j:=0 to high(tree[i-1]) do begin
       if pos(tree[i][m].effector,tree[i-1][j].receptor)>0 then begin
        m:=j;
        break;
       end;
      end;
     end;
    end;

  end;

  if Continuity=false then InteriorReceptor:='*';//        ()    curiosity
 end;
 
  memo4.Clear;  //      
  for i:=0 to high(skills) do begin
   if length(skills[i].effector)=1 then str:=skills[i].effector+' - '+skills[i].receptor
                                   else str:=skills[i].effector[2]+' - '+skills[i].receptor;
   memo4.Lines.Add(str);
  end;
end;

procedure TForm1.Forgetting; //  .    ,   ,   
begin
 setlength(skills,5); //    5  ,  
end;

procedure TForm1.Button1Click(Sender: TObject);
 var i:integer;
begin
 Button1.Enabled:=false;
 ismoov:=true;  //     
 Forgetting;     //    
 Creating;

 postsens:=nil;    //     Executing    Experiencing
 setlength(postsens,length(nowsens));
 for i:=0 to high(nowsens) do postsens[i]:=nowsens[i];

 Executing;
 CheckGoal;
 Experiencing;
 ismoov:=false; 
 Button1.Enabled:=true; 
end;

procedure TForm1.FormCreate(Sender: TObject);
 var i:integer;
begin
 randomize;
 event1:=CreateEvent(nil, false, false, nil);
 buf:=tbitmap.Create;
 buf.Width:=121;
 buf.Height:=121;
 buf.PixelFormat:=pf24bit;
 pole:=tbitmap.Create;
 pole.Width:=121;
 pole.Height:=121;
 pole.PixelFormat:=pf24bit;
 pole.LoadFromResourceName(hinstance,'POLE');
 setlength(PS,buf.Height);
 for i:=0 to buf.Height-1 do PS[i]:=buf.ScanLine[i];

 SetPos(''); //  

 memo4.Lines.Add('0 - L'); 
 memo4.Lines.Add('1 - R');
 memo4.Lines.Add('2 - U');
 memo4.Lines.Add('3 - D');
 memo4.Lines.Add('C - *');

 setlength(skills,5);      // 5  
 skills[0].receptor:='L';
 skills[0].effector:='e0';  //   0 - , 1 - , 2 - , 3 -   4 -  

 skills[1].receptor:='R';    //    
 skills[1].effector:='e1';   // e - effector

 skills[2].receptor:='U';
 skills[2].effector:='e2';
 
 skills[3].receptor:='D';
 skills[3].effector:='e3';

 skills[4].receptor:='*';
 skills[4].effector:='C';   // curiosity
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 bitblt(buf.Canvas.Handle,0,0,121,121,pole.Canvas.Handle,0,0,srccopy);
 bres_circle(FX,FY,13,255,0,0);
 bitblt(form1.Canvas.Handle,dX,dY,121,121,buf.Canvas.Handle,0,0,srccopy);
end;

procedure TForm1.CheckGoal;  //         
begin
 if GetPos=Goal then begin
  CheckBox1.Checked:=false;
  CheckBox1Click(nil);
  application.ProcessMessages;
 end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CloseHandle(event1);
 buf.Free;
 pole.Free;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 if CheckBox1.Checked then begin
  CheckBox1.Font.Style:=[fsbold];
  CheckBox1.Font.Color:=clred;
  setlength(nowsens,length(nowsens)+1);
  nowsens[high(nowsens)]:=''; //  -  ,       
 end else begin
  CheckBox1.Font.Style:=[];
  CheckBox1.Font.Color:=clblack;
 end;
 if GetPos=Goal then CheckBox1.Checked:=false; //   
end;

function TForm1.GetPos:char;
begin
 result:=soot[FY div 30,FX div 30];
end;

procedure TForm1.SetPos(x:char);
 var i,j:integer;
 find:boolean;
begin
 find:=true;
 for i:=0 to 3 do
  for j:=0 to 3 do if soot[i,j]=x then begin
   FX:=j*30+15;
   FY:=i*30+15;
   memo1.Clear;
   memo2.Clear;
   find:=false;
   form1.FormPaint(nil);
   InteriorReceptor:='';
   UpdateNowsens; //  
   break;
  end;
 if find then messagebox(form1.Handle,'   ','',mb_ok);
end;

procedure TForm1.UpdateNowsens;
begin
 nowsens:=nil;
 setlength(nowsens,1); //        
 nowsens[0]:=GetPos;

 if InteriorReceptor<>'' then begin     //   
  setlength(nowsens,length(nowsens)+1);
  nowsens[high(nowsens)]:=InteriorReceptor;
 end; 

 if checkbox1.Checked then begin   //   
  setlength(nowsens,length(nowsens)+1);
  nowsens[high(nowsens)]:=''; //  -  ,   ,  
 end;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if (ismoov=false)and(x>dX)and(y>dY)and(x<(dX+buf.Width))and(Y<(dY+buf.Height))then begin
  SetPos(soot[(Y-dY)div 30,(X-dX)div 30]);
  CheckGoal;
 end;
end;

end.
